
Code     segment
         assume    cs:code,ds:code
         org       100H

; ------ zobrazen vodnho textu

Start:   mov       dx,offset UvTxt
         mov       ah,9
         int       21h                      ; zobrazen vodnho textu

; ------ definice INT 23h

         mov       dx,offset INT23
         mov       ax,2523h
         int       21h                      ; pedefinovn INT 23h

; ------ pedefinovn zsobnku

         cmp       sp,offset Zasob          ; kontrola konce zsobnku
         jb        Start2                   ; chyba - nedostatek pamti
         mov       sp,offset Zasob          ; pedefinovn zsobnku

; ------ zmenen programu na minimum

         mov       ah,4ah
         mov       bx,(offset(Zasob-Start)+10fh)/16 ; velikost programu
         int       21h                      ; zmenen bloku programu
         jnc       Start4                   ; operace OK

; ------ chyba pamti

Start2:  mov       dx,offset MemTxt
Start3:  mov       ah,9
         int       21h

; ------ chybov nvrat

         mov       ax,4c02h
         int       21h                      ; nvrat s chybou

; ------ vytvoen datovho bufferu

Start4:  mov       ah,48h
         mov       bx,0fffh                 ; velikost datovho bufferu
         int       21h                      ; vytvoen datovho bufferu
         jnc       Start5                   ; buffer vytvoen OK
         mov       ah,48h
         int       21h                      ; druh poku so vytvoen bufferu
         jc        Start2                   ; chyba pamti
Start5:  mov       ds:[BuffSegm],ax         ; adresa bufferu
         mov       cl,4                     ; poet rotac
         shl       bx,cl                    ; pepoet na bajty
         mov       ds:[BuffSize],bx         ; velikost bufferu

; ------ pednastaven aktivnho disku

         mov       ah,19h
         int       21h                      ; poskytnut aktivnho disku
         mov       ds:[Disk],al             ; aktivn disk

; ------ pprava pkazovho dku

         mov       si,81h                   ; zatek pkazovho dku
         mov       bh,0
         mov       bl,ds:[si-1]             ; dlka pkazovho dku
         mov       byte ptr ds:[bx+si],0    ; oznaen konce textu

; ------ nalezen oznaen disku

         mov       dx,offset HelpTxt        ; text npovdy
         call      ParSpc                   ; nalezen zatku parametru
         jc        Start6                   ; nen nic zadno
         cmp       byte ptr ds:[si+1],":"   ; je to oznaen disku ?
         jne       Start56                  ; disk nen zadn
         call      ParChr                   ; naten znaku
         sub       al,"A"                   ; konverze na slo disku
         mov       ds:[Disk],al             ; oznaen disku

; ------ kontrola zadn

         cmp       al,32                    ; je slo disku ?
         jae       Start3                   ; chyba zadn
         call      ParChr                   ; zruen znaku ":"

; ------ naten oznaen HEX

         call      ParSpc                   ; vyputn mezer
         jc        Start6                   ; nen nic dalho zadno
Start56: call      ParHex                   ; naten parametru HEX
Start33: jc        Start3                   ; chyba zadn
         mov       ds:[Soucet],ax           ; pedpokldan kontroln souet
         or        byte ptr ds:[Param],1    ; pznak zadn soutu
         call      ParSpc                   ; je jet nco zadno ?
         cmc
         jc        Start33                  ; chyba - je jet nco zadno

; ------ stanoven informac o disku

Start6:  call      InitI25                  ; stanoven informac o disku
         jc        Start33                  ; njak chyba

; ------ hlen o zpracovan sti

Start7:  sti                                ; peruen povoleno
         call      DispKur                  ; zobrazen kurzoru operace

; ------ poet sektor ke ten

         mov       ax,word ptr ds:[UkazSekt] ; ukazatel sektor LOW
         mov       dx,word ptr ds:[UkazSekt+2] ; ukazatel sektor HIGH
         mov       cx,word ptr ds:[MaxSekt] ; poet sektor disku LOW
         mov       bx,word ptr ds:[MaxSekt+2] ; poet sektor disku HIGH
         sub       cx,ax                    ; zbyl sektory LOW
         sbb       bx,dx                    ; zbyl sektory HIGH
         jc        Start8                   ; peteen

; ------ omezen potu sektor

         jz        Start72                  ; nen vce sektor ne 0ffffh
         mov       cx,0ffffh                ; omezen potu sektor
Start72: cmp       cx,ds:[BuffSekt]         ; vejdou se do bufferu ?
         jbe       Start73                  ; poet sektor je OK
         mov       cx,ds:[BuffSekt]         ; omezen potu sektor
Start73: jcxz      Start8                   ; je ji cel disk

; ------ naten dalho bloku sektor z disku

         call      ReadSekt                 ; ten dalho bloku dat
         mov       dx,offset ReadTxt        ; text - chyba ten
         jc        Start33                  ; chyba ten dat z disku

; ------ zven ukazatele sektor

         add       word ptr ds:[UkazSekt],cx ; zven ukazatele sektor LOW
         adc       word ptr ds:[UkazSekt+2],0 ; penos HIGH

; ------ vpoet kontrolnho soutu sektor

         mov       ax,ds:[SektSize]         ; poet bajt na sektor
         mul       cx                       ; vpoet dlky dat v bajtech
         mov       cx,ax                    ; poet bajt ke kontrolnmu soutu
         mov       dx,ds:[Soucet0]          ; potan kontroln souet
         xor       si,si                    ; zatek dat
         push      ds
         mov       ds,ds:[BuffSegm]         ; adresa bufferu
         call      CheckSum                 ; kontroln souet bloku dat
         pop       ds
         mov       ds:[Soucet0],dx          ; pokraovn kontrolnho soutu

; ------ test peruen programu

         mov       ah,0bh
         int       21h
         cmp       al,0ffh
         jne       Start7                   ; nen pipraven znak
         mov       ah,08h
         int       21h
         cmp       al,27
         jne       Start7                   ; nen peruen

INT23:   push      cs
         pop       ds
         call      ClrKur                   ; vymazn kurzoru
         mov       al,3                     ; pznak peruen
         jmp       short Start9             ; konec

; ------ zobrazen vsledku

Start8:  call      ClrKur                   ; vymazn kurzoru
         mov       al,ds:[Disk]             ; disk
         add       ds:[SoucTxt1],al         ; oznaen disku
         mov       ax,ds:[Soucet0]          ; vypotan kontroln souet
         mov       di,offset SoucTxt2
         call      DekWord                  ; dekdovn sla kontr. soutu
         mov       dx,offset SoucTxt
         mov       ah,9
         int       21h                      ; zobrazen vsledku
         test      byte ptr ds:[Param],1    ; zadn kontroln souet ?
         jz        Start89                  ; nezadn

; ------ test, zda kontroln souet souhlas

         mov       ax,ds:[Soucet0]
         cmp       ax,ds:[Soucet]           ; souhlas kontroln souet ?
         je        Start84                  ; souhlas OK

         mov       dx,offset Souc4Txt
         mov       ah,9
         int       21h                      ; CRC nesouhlas
         mov       al,1
         jmp       short Start9

Start84: mov       dx,offset Souc3Txt
         mov       ah,9
         int       21h                      ; CRC souhlas

Start89: mov       al,0                     ; operace OK
Start9:  mov       ah,4ch
         int       21h

; *****************************************************************************
;
;                             Kontroln souet
;
; *****************************************************************************

; -----------------------------------------------------------------------------
;        Kontroln souet CRC bloku dat
; -----------------------------------------------------------------------------
; VSTUP: DS:SI=zatek bloku dat
;        CX=poet bajt
;        DX=vstupn hodnota kontrolnho soutu
; VSTUP:DX=vstupn hodnota kontrolnho soutu
; -----------------------------------------------------------------------------

CheckSum PROC      NEAR

         push      ax
         push      cx
         push      di
         jcxz      CheckSm2                 ; nen dn bajt
         mov       di,cx                    ; poet bajt pro kontroln souet
         cld                                ; smr nahoru

CheckSm1:lodsb                              ; a = fgetc(fp);
         xor       al,dh                    ; d = a ^= d;
         mov       dh,al
         mov       cl,4
         shr       al,cl                    ; a >>= 4;
         xor       al,dh                    ; d = a ^= d;
         mov       dh,al
         mov       cl,3
         ror       al,cl                    ; a = (a >> 3) | (a << 5);
         mov       ch,al                    ; f = a;
         and       al,1fh                   ; a &= 0x1f;
         xor       al,dl                    ; e = a ^= e;
         mov       dl,al
         mov       al,ch                    ; a = f;
         ror       al,1                     ; a = (a >> 1) | (a << 7);
         and       al,0f0h                  ; a &= 0xf0;
         xor       al,dl                    ; e = a ^= e;
         mov       dl,al
         mov       al,ch                    ; a = f & 0xe0;
         and       al,0e0h
         xor       al,dh                    ; a ^= d;
         mov       dh,dl                    ; d = e;
         mov       dl,al                    ; e = a;

         dec       di
         jnz       CheckSm1                 ; dal bajt

CheckSm2:pop       di
         pop       cx
         pop       ax
         ret

CheckSum ENDP


; *****************************************************************************
;
;                              Obsluha disku
;
; *****************************************************************************


; -----------------------------------------------------------------------------
;        naten CX sektor do datovho bufferu (od zatku)
; -----------------------------------------------------------------------------
; VSTUP: CX=poet sektor ke ten
;        DX:AX=poten sektor
;        DS=datov segment
; VSTUP:CY=chyba operace
; -----------------------------------------------------------------------------

ReadSekt PROC      NEAR

; ------ schova registr

         push      bp
         mov       bp,2                     ; poet pokus o naten dat

ReadSek1:push      ax
         push      bx
         push      cx
         push      dx
         push      ds

; ------ standardn obsluha INT 25h

         test      byte ptr ds:[Param],2    ; je obsluha paketem ?
         jnz       ReadSek2                 ; je obsluha paketem
         mov       dx,ax                    ; slo sektoru ke ten
         mov       al,ds:[Disk]             ; slo disku
         mov       ds,ds:[BuffSegm]         ; adresa datovho bufferu
         xor       bx,bx                    ; poten offset k naten dat
         jmp       short ReadSek4           ; naten dat

; ------ obsluha INT 25h paketem

ReadSek2:mov       bx,offset Paket          ; adresa paketu
         mov       ds:[bx],ax               ; slo sektoru LOW
         mov       ds:[bx+2],dx             ; slo sektoru HIGH
         mov       ds:[bx+4],cx             ; poet sektor
         mov       word ptr ds:[bx+6],0     ; adresa bufferu LOW
         mov       ax,ds:[BuffSegm]         ; adresa bufferu
         mov       ds:[bx+8],ax             ; adresa bufferu HIGH
         mov       cx,-1                    ; pznak obsluhy paketem
         mov       al,ds:[Disk]             ; slo disku

; ------ naten sektor do bufferu

ReadSek4:mov       cs:[Zasobnik],sp         ; schova ukazatele zsobnku
         int       25h                      ; proveden operace ten dat
         mov       sp,cs:[Zasobnik]         ; nvrat zsobnku

; ------ nvrat registr

         pop       ds
         pop       dx
         pop       cx
         pop       bx
         pop       ax

; ------ ppadn opakovn operace pi chyb

         jnc       ReadSek5                 ; operace dopadka OK
         dec       bp                       ; ta pokus
         jnc       ReadSek1                 ; opakovn operace

ReadSek5:pop       bp
         ret

ReadSekt ENDP

; -----------------------------------------------------------------------------
;        inicializace obsluhy INT 25h
; -----------------------------------------------------------------------------
; VSTUP: DS=datov segment
; VSTUP:CY=neplatn disk nebo nekompatibiln systm
;        DX=text chybovho hlen
; -----------------------------------------------------------------------------

InitI25  PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      ds

; ------ poskytnut tabulky parametr disku

         and       byte ptr ds:[Param],not 2 ; zruen pznaku obsluhy paketem
         mov       dl,ds:[disk]             ; disk
         mov       ch,dl                    ; schova sla disku
         inc       dx                       ; slo poadovanho disku
         mov       ax,32ffh
         int       21h                      ; poskytnut bloku parametr disku

; ------ test sprvnosti disku

         mov       dx,offset DiskTxt        ; text - chybn zadn disku
         cmp       al,0ffh                  ; je chyba ?
         je        InitI254                 ; je chyba - neplatn disk
         mov       dx,offset SystTxt        ; text - nekompatibiln systm
         cmp       ch,ds:[bx]               ; souhlas slo disku ?
         jne       InitI254                 ; slo disku nesouhlas - chyba
         pop       cx                       ; CX <- DS
         push      cx
         mov       ax,ds
         cmp       ax,cx                    ; zmnil se DS ?
         je        InitI254                 ; DS se nezmnil - chyba

; ------ celkov poet sektor

         mov       ax,ds:[bx+0dh]           ; max. slo alokanho bloku
         dec       ax                       ; poet alokanch blok
         xor       cx,cx                    ; CX <- 0
         mov       cl,ds:[bx+4]             ; maximln slo sektoru v bloku
         inc       cx                       ; poet sektor v alokanm bloku
         mul       cx                       ; vpoet potu sektor dat celkem
         add       ax,ds:[bx+0bh]           ; piten rezervovanch sektor
         adc       dx,0                     ; penos
         mov       word ptr cs:[MaxSekt],ax ; poet sektor disku celkem LOW
         mov       word ptr cs:[MaxSekt+2],dx ; poet sektor disku celkem HIGH
         jz        InitI253                 ; poet sektor nen vt ne ffffh
         or        byte ptr cs:[Param],2    ; pznak obsluhy INT 25h paketem

; ------ velikost sektoru

InitI253:mov       bx,ds:[bx+2]             ; poet bajt na sektor
         mov       cs:[SektSize],bx         ; velikost sektoru
         or        bx,bx
         mov       dx,offset SystTxt        ; text - nekompatibiln systm
         jz        InitI254                 ; chybn velikost sektoru
         mov       ax,cs:[BuffSize]         ; velikost bufferu
         xor       dx,dx                    ; DX <- 0
         div       bx                       ; poet sektor v bufferu
         mov       cs:[BuffSekt],ax         ; poet sektor v bufferu
         or        ax,ax                    ; je njak sektor ?
         jnz       InitI255                 ; je alespo 1 sektor v bufferu - OK
         mov       dx,offset MemTxt         ; text - nedostatek pamti
InitI254:stc                                ; pznak chyby

; ------ nvrat registr

InitI255:pop       ds
         pop       cx
         pop       bx
         pop       ax
         ret

InitI25  ENDP

; *****************************************************************************
;
;                           Obsluha zobrazen
;
; *****************************************************************************

; -----------------------------------------------------------------------------
;        vymazn kurzoru
; -----------------------------------------------------------------------------
; VSTUP: DS=datov segment
; -----------------------------------------------------------------------------

ClrKur   PROC      NEAR

         push      ax
         push      cx
         push      di
         push      es

         push      ds
         pop       es
         mov       di,offset HlasTxt+1
         mov       cx,offset(HlasTxtX-HlasTxt)-2
         mov       al," "
         cld
         rep       stosb
         mov       al,13
         stosb

         mov       ah,9
         mov       dx,offset HlasTxt
         int       21h

         pop       es
         pop       di
         pop       cx
         pop       ax
         ret

ClrKur   ENDP

; -----------------------------------------------------------------------------
;        zobrazen kurzoru operace
; -----------------------------------------------------------------------------
; VSTUP: DS=datov segment
; -----------------------------------------------------------------------------

DispKur  PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx
         push      si
         push      di
         push      es

; ------ vpoet pozice kurzoru

         mov       ax,word ptr ds:[UkazSekt] ; sektor LOW
         mov       dx,word ptr ds:[UkazSekt+2] ; sektor HIGH
         call      PozKur                   ; vpoet pozice kurzoru

; ------ dekdovn procent operace

         mov       ax,di
         mov       cl,10
         div       cl
         add       ah,"0"
         mov       ds:[HlasTxt0+1],ah       ; jednotky procent
         add       al,"0"
         cmp       al,"0"
         je        DispKur1
         mov       ds:[HlasTxt0],al

; ------ zpis znaku kurzoru

DispKur1:mov       al,178                   ; znak kurzoru
         mov       cx,si
         mov       di,offset Kurz+1
         sub       cx,di                    ; dlka kurzoru
         push      ds
         pop       es
         cld
         rep       stosb                    ; zpis kurzoru

; ------ dekdovn prbnho kontrolnho soutu

         mov       ax,ds:[Soucet0]          ; kontroln souet
         mov       di,offset Souc
         call      DekWord                  ; dekdovn slova

; ------ zobrazen hlen o prbhu operace

         mov       dx,offset HlasTxt
         mov       ah,9
         int       21h                      ; zobrazen hlen

; ------ nvrat registr

         pop       es
         pop       di
         pop       si
         pop       dx
         pop       cx
         pop       ax
         ret

DispKur  ENDP

; -----------------------------------------------------------------------------
;        vpoet pozice kurzoru
; -----------------------------------------------------------------------------
; VSTUP: DX:AX=slo sektoru
; VSTUP:SI=adresa kurzoru v bufferu
;        DI=procenta operace 0 a 99
; -----------------------------------------------------------------------------

PozKur   PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ normalizace ukazatel

         mov       bx,word ptr ds:[MaxSekt+2] ; poet sektor HIGH
         mov       cx,word ptr ds:[MaxSekt] ; poet sektor LOW
PozKur1: mov       di,dx
         or        di,bx                    ; je HIGH = 0 ?
         jz        PozKur2                  ; registry jsou OK
         shr       dx,1
         rcr       ax,1
         shr       bx,1
         rcr       cx,1
         jmp       short PozKur1

; ------ vpoet adresy ukazatele

PozKur2: cmp       ax,cx
         jb        PozKur3
         mov       ax,cx
         jcxz      PozKur4
         dec       ax                       ; omezen na posledn sektor
PozKur3: mov       bx,100                   ; poet procent max.
         mul       bx                       ; pedvynsoben 100x
         div       cx                       ; vpoet procent
PozKur4: mov       di,ax                    ; procenta operace
         mov       si,ax                    ; offset kurzoru
         shr       si,1
         shr       si,1                     ; ukazatel
         add       si,offset kurz+1         ; adresa kurzoru

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

PozKur   ENDP

; -----------------------------------------------------------------------------
;        Dekdovn sla HEX
; -----------------------------------------------------------------------------
; VSTUP: ES:DI=ukldac adresa textu
; -----------------------------------------------------------------------------

DekWord  PROC      NEAR

         xchg      ah,al                    ; AL <- vy bajt slova
         call      DekByte                  ; dekdovn vyho bajtu slova
         xchg      ah,al                    ; AL <- ni bajt slova

; ------ dekdovn bajtu AL v HEX formtu

DekByte: push      ax                       ; schova bajtu k dekdovn
         ror       al,1
         ror       al,1
         ror       al,1
         ror       al,1                     ; nastaven vy tetrdy
         call      DekHex                   ; dekdovn ni tetrdy bajtu
         pop       ax                       ; nvrat bajtu k zobrazen

; ------ dekdovn tetrdy AL v HEX formtu

DekHex:  push      ax
         and       al,0fh                   ; maska ni tetrdy
         add       al,"0"                   ; korekce na ASCII znak
         cmp       al,"9"                   ; je psmeno ?
         jbe       DekHex2                  ; je slice - OK
         add       al,7                     ; korekce na psmeno
DekHex2: cld
         stosb                              ; uloen znaku do bufferu
         pop       ax
         ret

DekWord  ENDP

; *****************************************************************************
;
;                          Rozbor pkazovho dku
;
; *****************************************************************************

; -----------------------------------------------------------------------------
;        naten sla HEX
; -----------------------------------------------------------------------------

ParHex   PROC      NEAR

         push      dx
         xor       dx,dx                    ; stada sla
         call      ParSpc                   ; vyputn mezer
         call      ParHx                    ; prvn znak HEX
         jc        ParHex3                  ; chyba
ParHex1: shl       dx,1
         shl       dx,1
         shl       dx,1
         shl       dx,1
         or        dl,al
         call      ParHx                    ; dal znak
         jnc       ParHex1
         clc                                ; operace OK

ParHex3: xchg      ax,dx
         pop       dx
         ret

ParHex   ENDP

; -----------------------------------------------------------------------------
;        naten jednoho znaku HEX
; -----------------------------------------------------------------------------

ParHx    PROC      NEAR

         call      ParChr                   ; naten dalho znaku
         jc        ParHx3                   ; nen dal znak
         cmp       al,"0"
         jb        ParHx3                   ; nen platn znak
         cmp       al,"9"+1
         jb        ParHx1                   ; znak je OK
         cmp       al,"A"
         jb        ParHx2                   ; nen platn znak
         cmp       al,"F"
         ja        ParHx2                   ; nen platn znak
         sub       al,7

ParHx1:  sub       al,"0"                   ; korekce na slo
         ret

ParHx2:  dec       si                       ; nvrat znaku
         stc                                ; pznak chyby
ParHx3:  ret

ParHx    ENDP

; -----------------------------------------------------------------------------
;        vyputn mezer z pkazovho dku
; -----------------------------------------------------------------------------

ParSpc   PROC      NEAR

         call      ParChr                   ; naten znaku z pkazovho dku
         jc        ParSpc2                  ; konec textu
         je        ParSpc                   ; mezera - vyputn
         dec       si                       ; nvrat znaky
ParSpc2: ret

ParSpc   ENDP

; -----------------------------------------------------------------------------
;        naten znaku z pkazovho dku
; -----------------------------------------------------------------------------

ParChr   PROC      NEAR

; ------ naten znaku z pkazovho dku

         cld
         lodsb                              ; naten znaku z pkaz. dku
         cmp       al,"["
         je        ParChr
         cmp       al,"]"
         je        ParChr

; ------ nhrada tabeltoru mezerou

         cmp       al,9                     ; je tabeltor ?
         jne       ParChr1                  ; nen tabeltor
         mov       al," "                   ; nhrada tabeltoru mezerou

; ------ konverze na velk psmeno

ParChr1: cmp       al,"a"
         jb        ParChr2
         cmp       al,"z"
         ja        ParChr2
         sub       al,32                    ; konverze na velk psmeno

; ------ kontrola, zda je konec dku

ParChr2: cmp       al," "                   ; je konec dku ?
         jae       ParChr3                  ; nen konec dku
         dec       si                       ; nvrat znaku
         mov       byte ptr ds:[si],0       ; oznaen konce textu
ParChr3: ret

ParChr   ENDP

; *****************************************************************************
;
;                                 Data
;
; *****************************************************************************

UvTxt    db        'CHSMDISK V1.0 - kontrolni soucet disku; (c) Miroslav Nemecek',13,10,'$'
MemTxt   db        'Chyba - nedostatek pameti !',7,13,10,'$'
DiskTxt  db        'Chybne zadani disku !',13,10,'$'
SystTxt  db        'Nekompatibilni operacni system !',13,10,'$'
ReadTxt  db        'Chyba cteni dat z disku !',13,10,'$'

HelpTxt  db        'Zadejte: CHSMDISK  [disk:] [CRC]',13,10
         db        '           disk:  oznaceni disku ke kontrole',13,10
         db        '           CRC    predpokladany kontrolni soucet',13,10
         db        '$'

HlasTxt  db        13,'Zpracovano '
HlasTxt0 db        ' 0%  '
Kurz     db        '[ . . . . . . . . . . . . ]   CRC='
Souc     db        'FFFF $'
HlasTxtX label     near
         db        '$'

SoucTxt  db        'Kontrolni soucet disku '
SoucTxt1 db        'A: je '
SoucTxt2 db        'FFFF.',13,10,'$'

Souc3Txt db        'Kontrolni soucet souhlasi.',13,10,'$'
Souc4txt db        'Kontrolni soucet NESOUHLASI ! ',7,13,10,'$'

Param    db        0                        ; parametry
                                            ;   bit 0: 1=zadn kontroln souet
                                            ;   bit 1: 1=obsluha INT 25h paketem

UkazSekt dd        0                        ; ukazatel tench sektor

Soucet0  dw        -1                       ; potan kontroln souet

Soucet   dw        ?                        ; pedpokldan kontroln souet


Disk     db        ?                        ; slo disku

MaxSekt  dd        ?                        ; celkov poet sektor disku
SektSize dw        ?                        ; poet bajt na sektor
BuffSekt dw        ?                        ; maximln poet sektor v bufferu

Zasobnik dw        ?                        ; schova ukazatele zsobnku

BuffSegm dw        ?                        ; adresa datovho bufferu
BuffSize dw        ?                        ; velikost bufferu (bajt)

Paket    label     word                     ; datov paket pro ten sektor
PaketSiz dd        ?                        ; slo sektoru
PaketNum dw        ?                        ; poet sektor
PaketAdr dd        ?                        ; adresa k naten sektor

         dw        100h dup(?)              ; zsobnk
Zasob    label     byte                     ; konec zsobnku

Code     ends
         end       start
